<template>
 <div class="box p-5 md:p-8 mb-10 bg-white rounded-lg shadow-md dark:bg-gray-800">
    <form @submit.prevent="form.post('/employee/user', { preserveScroll: true })">
      <h3 class="text-xl font-bold text-gray-700 dark:text-gray-200 mb-4">Create User</h3>

      <!-- Name and Gender -->
      <div class="w-full flex flex-wrap mb-4">
        <div class="w-full md:w-1/2 pr-2 mb-4 md:mb-0">
          <label for="name" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Name</label>
          <input id="name" v-model="form.name" class="input w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="text" placeholder="Enter name" />
          <div v-if="form.errors.name" class="text-error mt-1">{{ form.errors.name }}</div>
        </div>
        <div class="w-full md:w-1/2 pl-2">
          <label for="gender" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Gender</label>
          <select id="gender" v-model="form.gender" class="dropdown w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200">
            <option value="Male">Male</option>
            <option value="Female">Female</option>
            <option value="Other">Other</option>
          </select>
          <div v-if="form.errors.gender" class="text-error mt-1">{{ form.errors.gender }}</div>
        </div>
      </div>

      <!-- Email -->
      <div class="w-full flex flex-wrap mb-4">
        <div class="w-full">
          <label for="email" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Email</label>
          <input id="email" v-model="form.email" class="input w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="email" placeholder="Enter email" />
          <div v-if="form.errors.email" class="text-error mt-1">{{ form.errors.email }}</div>
        </div>
      </div>

      <!-- Nationality and Foreign Nationality -->
      <div class="w-full flex flex-wrap mb-4">
        <div class="w-full md:w-1/2 pr-2 mb-4 md:mb-0">
          <label for="nationality" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Nationality</label>
          <select id="nationality" v-model="form.nationality" class="dropdown w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200">
            <option value="Bhutanese">Bhutanese</option>
            <option value="Foreigner">Foreigner</option>
          </select>
          <div v-if="form.errors.nationality" class="text-error mt-1">{{ form.errors.nationality }}</div>
        </div>
        <div class="w-full md:w-1/2 pl-2">
          <label for="foreign-nationality" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Foreign Nationality</label>
          <input id="foreign-nationality" v-model="form.foreign_nationality" :disabled="form.nationality === 'Bhutanese'" class="input w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="text" placeholder="e.g., Indian" />
          <div v-if="form.errors.foreign_nationality" class="text-error mt-1">{{ form.errors.foreign_nationality }}</div>
        </div>
      </div>

      <!-- Date of Birth and Date of Join -->
      <div class="w-full flex flex-wrap mb-4">
        <div class="w-full md:w-1/2 pr-2 mb-4 md:mb-0">
          <label for="dob" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Date of Birth</label>
          <input id="dob" v-model="form.dob" class="input w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="date" />
          <div v-if="form.errors.dob" class="text-error mt-1">{{ form.errors.dob }}</div>
        </div>
        <div class="w-full md:w-1/2 pl-2">
          <label for="doj" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Date of Join</label>
          <input id="doj" v-model="form.doj" class="input w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="date" />
          <div v-if="form.errors.doj" class="text-error mt-1">{{ form.errors.doj }}</div>
        </div>
      </div>

      <!-- CID -->
      <div class="w-full flex flex-wrap mb-4">
        <div class="w-full">
          <label for="cid" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">CID</label>
          <input id="cid" v-model="form.cid" class="input w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="text" placeholder="Enter CID" />
          <div v-if="form.errors.cid" class="text-error mt-1">{{ form.errors.cid }}</div>
        </div>
      </div>

      <!-- Department and Designation -->
      <div class="w-full flex flex-wrap mb-4">
        <div class="w-full md:w-1/2 pr-2 mb-4 md:mb-0">
          <label for="department" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Department</label>
          <select id="department" v-model="form.department" class="dropdown w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200">
            <option>No Department</option>
            <option v-for="department in departments" :key="department.id" :value="department.id">{{ department.name }}</option>
          </select>
          <div v-if="form.errors.department" class="text-error mt-1">{{ form.errors.department }}</div>
        </div>
        <div class="w-full md:w-1/2 pl-2">
          <label for="designation" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Designation</label>
          <input id="designation" v-model="form.designation" :disabled="form.department === 'No Department'" class="input w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="text" placeholder="Enter Text" />
          <div v-if="form.errors.designation" class="text-error mt-1">{{ form.errors.designation }}</div>
        </div>
      </div>

      <!-- Role -->
      <div class="w-full flex flex-wrap mb-4">
        <div class="w-full">
          <label for="role_id" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Role</label>
          <select id="role_id" v-model="form.role_id" class="dropdown w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200">
            <option v-for="role in roles" :key="role.id" :value="role.id">{{ role.name }}</option>
          </select>
          <div v-if="form.errors.role_id" class="text-error mt-1">{{ form.errors.role_id }}</div>
        </div>
      </div>

      <!-- Dynamic Fields -->
      <div v-if="roleFields.length > 0" class="mb-4">
        <div class="text-base font-bold text-gray-700 dark:text-gray-200 mb-3">Master details (Fields with <span class="text-orange-500">*</span> means that it is required)</div>
        <div class="space-y-4">
          <div v-for="(roleField, index) in roleFields" :key="roleField.id" class="flex flex-col">
            <label :class="{'opacity-50': roleField.foreigner_field && form.nationality === 'Bhutanese'}" class="text-sm font-medium text-gray-700 dark:text-gray-300">{{ index + 1 }}. {{ roleField.field.name }} <span v-if="roleField.foreigner_field" class="text-orange-500">(Only for foreigners)</span><span v-if="roleField.field.required" class="text-lg text-orange-500">*</span></label>
            <fieldset :disabled="roleField.foreigner_field && form.nationality === 'Bhutanese'" class="mb-1">
              <input v-if="roleField.field.type === 'Text'" v-model="form.filled_role_fields[index].value" class="input w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="text" />
              <input v-else-if="roleField.field.type === 'Number'" v-model="form.filled_role_fields[index].value" class="input w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="number" />
              <input v-else-if="roleField.field.type === 'Date'" v-model="form.filled_role_fields[index].value" class="input w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="date" />
              <input v-else-if="roleField.field.type === 'File'" @change="(event) => form.filled_role_fields[index].value = event.target.files[0]" class="input-file w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200" type="file" />
              <textarea v-else-if="roleField.field.type === 'Text Area'" v-model="form.filled_role_fields[index].value" class="textarea w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200"></textarea>
              <div v-else-if="roleField.field.type === 'Checkbox'" class="flex flex-col space-y-2">
                <div v-for="option in roleField.field.options" :key="option.id" class="flex items-center">
                  <input v-model="form.filled_role_fields[index].value" :value="option.id" type="checkbox" class="checkbox mr-2" />
                  <label class="text-sm dark:text-gray-300">{{ option.value }}</label>
                </div>
              </div>
              <div v-else-if="roleField.field.type === 'Radio Button'" class="flex flex-col space-y-2">
                <div v-for="option in roleField.field.options" :key="option.id" class="flex items-center">
                  <input v-model="form.filled_role_fields[index].value" :value="option.id" type="radio" class="radio mr-2" />
                  <label class="text-sm dark:text-gray-300">{{ option.value }}</label>
                </div>
              </div>
              <select v-else-if="roleField.field.type === 'Dropdown'" v-model="form.filled_role_fields[index].value" class="dropdown w-full border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 dark:bg-gray-700 dark:text-gray-200">
                <option v-for="option in roleField.field.options" :key="option.id">{{ option.value }}</option>
              </select>
              <div v-if="form.errors[`${roleField.id}id`]" class="text-error mt-1">{{ form.errors[`${roleField.id}id`] }}</div>
            </fieldset>
            <div class="text-sm flex flex-col md:flex-row gap-x-5 mt-2">
              <label v-if="roleField.issuable" class="text-orange-500 font-semibold flex items-center">
                <i class="fa-solid fa-hand-holding-hand mr-1"></i> Issuable
              </label>
              <label v-if="roleField.alertable" class="text-orange-500 font-semibold flex items-center">
                <i class="fa-solid fa-circle-exclamation mr-1"></i> Alert ({{ roleField.alert_period }})
              </label>
            </div>
          </div>
        </div>
      </div>

      <!-- Actions -->
      <div class="flex gap-x-3 mt-4 flex-row-reverse">
        <button type="submit" class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2">Save</button>
    <Link href="/employee/user" class="btn bg-gray-200 text-gray-700 px-4 py-2 ml-3 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">Cancel</Link>
      </div>
    </form>
  </div>
</template>

<script setup>
import { useForm, Link } from '@inertiajs/vue3';
import { ref, watch } from 'vue';

const props = defineProps({
  roles: Array,
  departments: Array
})

const roleFields = ref(props.roles[0].fields.sort((roleFieldA, roleFieldB) => roleFieldA.field.index - roleFieldB.field.index));

const form = useForm({
  name: '',
  gender: 'Male',
  email: '',
  nationality: 'Bhutanese',
  foreign_nationality: null,
  dob: null,
  doj: null,
  cid: null,
  department: 'No Department',
  designation: '',
  role_id: props.roles[0].id,
  filled_role_fields: props.roles[0].fields.sort((roleFieldA, roleFieldB) => roleFieldA.field.index - roleFieldB.field.index).map(
    (roleField) => roleField.field.type === 'Checkbox' ? { roleField: roleField, value: [] } : { roleField: roleField, value: null })
});

watch(() => form.role_id, (value) => {
  //update current role fields
  var targetFields = props.roles.find((role) => role.id === value).fields
  targetFields.forEach(roleField => {
    if (roleField.field.type === 'Checkbox' || roleField.field.type === 'Radio Button' || roleField.field.type === 'Dropdown') {
      roleField.field.options.sort((optionA, optionB) => optionA.index - optionB.index);
    }
  });
  roleFields.value = targetFields.sort((roleFieldA, roleFieldB) => roleFieldA.field.index - roleFieldB.field.index);

  //refresh values in forms
  form.filled_role_fields = new Array(targetFields.length);
  roleFields.value.forEach((roleField, index) => {
    if (roleField.field.type === 'Checkbox') {
      form.filled_role_fields[index] = { roleField: roleField, value: [] };
    } else {
      form.filled_role_fields[index] = { roleField: roleField, value: null };
    }
  })
})
</script>

<style scoped>
.input, .dropdown, .textarea, .checkbox, .radio {
  transition: all 0.3s ease;
}

.input:focus, .dropdown:focus, .textarea:focus, .checkbox:focus, .radio:focus {
  border-color: #2563eb;
  box-shadow: 0 0 0 1px #2563eb;
}

.input-file {
  display: block;
  width: 100%;
}

.text-error {
  color: #e53e3e;
}

.dark .text-error {
  color: #f56565;
}
</style>